"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @file index.ts
 * @author imcuttle
 *
 */
var React = require("react");
var p = require("prefix-classname");
var cx = p('');
var c = p('rcp-loading-wrapper__');
var LoadingWrapper = /** @class */ (function (_super) {
    __extends(LoadingWrapper, _super);
    function LoadingWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            couldRender: false
        };
        _this.timer = null;
        return _this;
    }
    LoadingWrapper.prototype.killTimer = function () {
        clearTimeout(this.timer);
        this.timer = null;
    };
    LoadingWrapper.prototype.register = function () {
        var _this = this;
        if (this.props.renderLoadingDelayMs) {
            if (this.timer) {
                this.killTimer();
            }
            this.timer = setTimeout(function () {
                _this.setState({
                    couldRender: true
                });
            }, this.props.renderLoadingDelayMs);
        }
    };
    LoadingWrapper.prototype.updateTimer = function (prevProps, isFirst) {
        if (isFirst === void 0) { isFirst = false; }
        if (!this.props.isLoading) {
            this.killTimer();
            this.setState({
                couldRender: false
            });
            return;
        }
        var couldDelay = (isFirst && this.props.withDelayRenderFirstly) || !isFirst;
        if (!couldDelay) {
            if (this.props.isLoading) {
                this.killTimer();
                this.setState({
                    couldRender: true
                });
            }
        }
        else {
            if (this.props.renderLoadingDelayMs) {
                if (this.props.isLoading) {
                    this.register();
                }
            }
            else {
                if (this.props.isLoading) {
                    this.killTimer();
                    this.setState({
                        couldRender: true
                    });
                }
            }
        }
    };
    LoadingWrapper.prototype.componentDidMount = function () {
        this.updateTimer({ isLoading: false }, true);
    };
    LoadingWrapper.prototype.componentDidUpdate = function (prevProps) {
        this.updateTimer(prevProps);
    };
    Object.defineProperty(LoadingWrapper.prototype, "couldRender", {
        get: function () {
            return this.state.couldRender;
        },
        enumerable: true,
        configurable: true
    });
    LoadingWrapper.prototype.render = function () {
        var _a = this.props, className = _a.className, LoadingComponent = _a.LoadingComponent;
        return (React.createElement("div", { className: c('container', !this.couldRender && 'hide', className) },
            this.props.children,
            React.createElement("div", { className: c('mask') },
                React.createElement("div", { className: c('main') }, !!LoadingComponent && React.createElement(LoadingComponent)))));
    };
    LoadingWrapper.defaultProps = {
        isLoading: false,
        // 渲染Loading 延迟ms
        renderLoadingDelayMs: 1000,
        // 是否首次的时候 delay 渲染 loading
        withDelayRenderFirstly: false,
        LoadingComponent: null
    };
    return LoadingWrapper;
}(React.PureComponent));
exports.default = LoadingWrapper;
//# sourceMappingURL=index.js.map